/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.*;

public class VasEnvoiMail extends Applet {
  Label lEtat,lDe,lA,lSujet;
  TextArea taContenu;
  TextField tDe,tA,tSujet;
  Button bProc;
  //pour passer d'une case a l'autre avec tabulation
  public Component[] compo;

  public String getAppletInfo() {
    return (new String("VasEnvoiMail v2.2, 9 mars 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //constructeur
  public VasEnvoiMail() {
    setLayout(null);
    setBackground(Color.lightGray);
    lEtat=new Label("Entrez votre e-mail, le destinataire et faites Envoyer !");
    lEtat.reshape(10,10,360,25);
    add(lEtat);
    lDe=new Label("De :");
    lDe.reshape(10,45,40,25);
    add(lDe);
    tDe=new TextField("");
    tDe.reshape(75,45,160,25);
    add(tDe);
    lA=new Label("A :");
    lA.reshape(235,45,40,25);
    add(lA);
    tA=new TextField("");
    tA.reshape(285,45,170,25);
    add(tA);

    bProc=new Button("Envoyer !");
    bProc.reshape(385,10,70,30);
    add(bProc);

    lSujet=new Label("Sujet :");
    lSujet.reshape(10,80,65,25);
    add(lSujet);
    tSujet=new TextField("Pas de sujet");
    tSujet.reshape(75,80,380,25);
    add(tSujet);

    taContenu=new TextArea();
    taContenu.reshape(20,115,435,210);
    add(taContenu);
    taContenu.appendText("Pour envoyer un message, tapez votre adresse e-mail,");
    taContenu.appendText("\nl'e-mail du destinataire, entrez le sujet et le contenu");
    taContenu.appendText("\net faites Envoyer !");
    taContenu.appendText("\n(C) 1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    resize(470,340);
  }//fin constructeur

  public void init() {
    compo=new Component[5];
    compo[0]=tDe;
    compo[1]=tA;
    compo[2]=tSujet;
    compo[3]=taContenu;
    compo[4]=bProc;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//fin init

  public boolean handleEvent(Event e) {
    //pour passer d'une case a l'autre avec tabulation
    if(e.id==Event.KEY_PRESS && e.key=='\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //en IE4, le texte reste selectionne
          //c'est pas joly, donc on de-selectionne avant de partir
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //s'il y a un composant "disabled", on passe plus loin
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while(!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }
      }
      return false;
    }//fin '\t'

    if(e.target==bProc && (e.arg==bProc.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      String sFrom=tDe.getText();
      String sTo=tA.getText();
      String sSubject=tSujet.getText();
      String sContents=taContenu.getText();
      if(sFrom.length()==0 || sTo.length()==0 || sSubject.length()==0 || sContents.length()==0) {
        lEtat.setText("Veillez remplir tous les champs !");
        return true;
      }
      bProc.disable();//on ne peut pas envoyer 2 fois DE SUITE
      //si Envoyer appuye, on initialise le socket
      //et on envoie la requete au serveur
      goConnexion(sFrom, sTo, sSubject, sContents);
      return true;
    }
    return false;//les autres evenements ne seront pas traites
  }//fin de handleEvent

  //si l'utilisateur charge une autre page, on continue quand meme
  public void stop() {return;}

  //pour lire la reponse du serveur
  boolean lireReponse(DataInputStream in) {
    String line="";
    try {
      line=in.readLine();
    }
    catch(IOException e) {lEtat.setText("Probleme lecture reponse"); bProc.enable(); return true;}
    if(line.startsWith("4") || line.startsWith("5")) {
      lEtat.setText("Err : "+line);
      bProc.enable();
      return true;
    }
    else return false;
  }//fin lireReponse

  public void goConnexion(String from, String to, String subj, String data) {
    try {
      lEtat.setText("Connexion en cours..");
      Socket sock=new Socket(getCodeBase().getHost(),25);
      DataOutputStream out=new DataOutputStream(sock.getOutputStream());
      DataInputStream in=new DataInputStream(sock.getInputStream());
      lEtat.setText("Connexion etablie, envoi des donnees");

      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("HELO vasile25.md\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("MAIL FROM:<"+from+">\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("RCPT TO:<"+to+">\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("DATA\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      if(subj!=null) out.writeBytes("Subject: "+subj+"\n\n");
      out.writeBytes(data+"\r\n.\r\nQUIT\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      sock.close();
      lEtat.setText("Bien envoye, vous pouvez ecrire un autre message");
      bProc.enable();
    }
    catch(IOException e) {lEtat.setText("Impossible de se connecter ou Cnx fermee"); bProc.enable();}
  };//fin goConnexion
}//fin classe VasEnvoiMail
